
Ruby - Bug #7860

Passing --libdir to ./configure causes Gem.ruby to point to an incorrect ruby interpreter path

02/16/2013 08:31 AM - cwgem (Chris White)

Status: Closed   

Priority: Normal   

Assignee: nobu (Nobuyoshi Nakada)   

Target version: 2.0.0   

ruby -v: ruby 2.0.0dev (2013-02-16 trunk 39262)

[x86_64-linux]

Backport:  

Description

How I reproduce:

# git clone git://github.com/ruby/ruby.git

# autoreconf

# ./configure --libdir=/usr/local/lib64

# make clean && make && make install

# /usr/local/bin/ruby -e 'puts Gem.ruby'

/bin/ruby

 

The problem is how topdir is set with tool/mkconfig.rb. This is a diff between ./configure and ./configure --libdir=/usr/local/lib64:

--- /root/rbconfig.rb   2013-02-15 15:20:15.016942074 -0800

+++ /usr/local/lib64/ruby/2.0.0/x86_64-linux/rbconfig.rb        2013-02-15 15:14:20.500932606 -080

0

@@ -6,7 +6,7 @@

   RUBY_VERSION == "2.0.0" or

     raise "ruby lib version (2.0.0) doesn't match executable version (#{RUBY_VERSION})"

 

-  TOPDIR = File.dirname(__FILE__).chomp!("/lib/ruby/2.0.0/x86_64-linux")

+  TOPDIR = File.dirname(__FILE__).chomp!("/usr/local/lib64/ruby/2.0.0/x86_64-linux")

   DESTDIR = '' unless defined? DESTDIR

   CONFIG = {}

   CONFIG["DESTDIR"] = DESTDIR

@@ -35,7 +35,7 @@

   CONFIG["rubyhdrdir"] = "$(includedir)/$(RUBY_VERSION_NAME)"

   CONFIG["UNIVERSAL_INTS"] = ""

   CONFIG["UNIVERSAL_ARCHNAMES"] = ""

-  CONFIG["configure_args"] = ""

+  CONFIG["configure_args"] = " '--libdir=/usr/local/lib64'"

   CONFIG["vendorarchdir"] = "$(vendorlibdir)/$(sitearch)"

   CONFIG["vendorlibdir"] = "$(vendordir)/$(ruby_version)"

   CONFIG["vendordir"] = "$(rubylibprefix)/vendor_ruby"

@@ -199,7 +199,7 @@

   CONFIG["DEFS"] = ""

   CONFIG["mandir"] = "$(datarootdir)/man"

   CONFIG["localedir"] = "$(datarootdir)/locale"

-  CONFIG["libdir"] = "$(exec_prefix)/lib"

+  CONFIG["libdir"] = "$(DESTDIR)/usr/local/lib64"

   CONFIG["psdir"] = "$(docdir)"

   CONFIG["pdfdir"] = "$(docdir)"

   CONFIG["dvidir"] = "$(docdir)"

 

Notice how topdir changes. I think this might have been caused by the tool/mkconfig.rb changes here:

https://github.com/ruby/ruby/commit/29c214e4a058fc4017ab0c0bf5c36b5bad203b5b

Related issues:
https://github.com/ruby/ruby/commit/29c214e4a058fc4017ab0c0bf5c36b5bad203b5b


Related to Ruby - Bug #7871: exec_prefix regression breaks mingw Closed 02/17/2013

Related to Ruby - Bug #18373: Bundled gem (RBS, debug) extensions are not pro... Closed

Associated revisions

Revision 62711da25352ac195013e0b81cd6343f8f39b9b5 - 02/16/2013 03:45 AM - nobu (Nobuyoshi Nakada)

configure.in: unexpand exec_prefix etc

configure.in: unexpand arch sitearch and exec_prefix values, so

directly specified bindir, libdir, rubyprefix, etc can be properly

substituted.  [ruby-core:52296] [Bug #7860]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@39267 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 62711da2 - 02/16/2013 03:45 AM - nobu (Nobuyoshi Nakada)

configure.in: unexpand exec_prefix etc

configure.in: unexpand arch sitearch and exec_prefix values, so

directly specified bindir, libdir, rubyprefix, etc can be properly

substituted.  [ruby-core:52296] [Bug #7860]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@39267 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision bb7e19c8e9ca34991dedbe2da84db5605cc80834 - 02/16/2013 04:40 AM - nobu (Nobuyoshi Nakada)

configure.in: don't substitute exec_prefix itself

configure.in (shvar_to_cpp): do not substitute exec_prefix itself

with RUBY_EXEC_PREFIX, which cause recursive definition.

[ruby-core:52296] [Bug #7860]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@39273 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision bb7e19c8 - 02/16/2013 04:40 AM - nobu (Nobuyoshi Nakada)

configure.in: don't substitute exec_prefix itself

configure.in (shvar_to_cpp): do not substitute exec_prefix itself

with RUBY_EXEC_PREFIX, which cause recursive definition.

[ruby-core:52296] [Bug #7860]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@39273 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 855f97202af9c55307a19c45c4a8d95cfb7d99d0 - 02/19/2013 06:50 AM - nobu (Nobuyoshi Nakada)

merge revision(s) 39267,39273,39294,39298,39313:

    * configure.in: unexpand arch sitearch and exec_prefix values, so

      directly specified bindir, libdir, rubyprefix, etc can be properly

      substituted.  [ruby-core:52296] [Bug #7860]

    * configure.in (shvar_to_cpp): do not substitute exec_prefix itself

      with RUBY_EXEC_PREFIX, which cause recursive definition.

      [ruby-core:52296] [Bug #7860]

    * configure.in (unexpand_shvar): regularize a shell variable by

      unexpanding shell variables in it.

    * configure.in (unexpand_shvar): regularize a shell variable by

      unexpanding shell variables in it.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_0_0@39320 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 855f9720 - 02/19/2013 06:50 AM - nobu (Nobuyoshi Nakada)

merge revision(s) 39267,39273,39294,39298,39313:

    * configure.in: unexpand arch sitearch and exec_prefix values, so

      directly specified bindir, libdir, rubyprefix, etc can be properly

      substituted.  [ruby-core:52296] [Bug #7860]

    * configure.in (shvar_to_cpp): do not substitute exec_prefix itself

      with RUBY_EXEC_PREFIX, which cause recursive definition.
      [ruby-core:52296] [Bug #7860]

    * configure.in (unexpand_shvar): regularize a shell variable by

      unexpanding shell variables in it.

    * configure.in (unexpand_shvar): regularize a shell variable by

      unexpanding shell variables in it.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_0_0@39320 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision b501eda42f5ca7aa277e337d3cea933a0220d2af - 03/04/2013 02:37 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 39284: [Backport #7860]

    * tool/mkconfig.rb: remove prefix from rubyarchdir.

      r39267 expands variables, it changes expansion timing,

      breaks RbConfig::CONFIG["includedir"] and building

      extension libraries with installed ruby.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_0_0@39581 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision b501eda4 - 03/04/2013 02:37 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 39284: [Backport #7860]

    * tool/mkconfig.rb: remove prefix from rubyarchdir.

      r39267 expands variables, it changes expansion timing,

      breaks RbConfig::CONFIG["includedir"] and building

      extension libraries with installed ruby.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_0_0@39581 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 02/16/2013 12:45 PM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

- % Done changed from 0 to 100

This issue was solved with changeset r39267.

Chris, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.

May Ruby be with you.

configure.in: unexpand exec_prefix etc

configure.in: unexpand arch sitearch and exec_prefix values, so

directly specified bindir, libdir, rubyprefix, etc can be properly

substituted.  [ruby-core:52296] [Bug #7860]

#2 - 02/19/2013 01:03 PM - nobu (Nobuyoshi Nakada)

- Category set to build

- Status changed from Closed to Assigned

- Assignee set to mame (Yusuke Endoh)

- Target version set to 2.0.0

I think this will be necessary for 2.0.0.

revisions are r39267,39273,39294,39298,39313.

#3 - 02/19/2013 01:13 PM - nobu (Nobuyoshi Nakada)

And r39284,r39297.

#4 - 02/19/2013 01:26 PM - nobu (Nobuyoshi Nakada)

Sorry, patches for tool/mkconfig.rb are not necessary as long as libdir is under exec_prefix.

And the case libdir is outside exec_prefix is not supported in trunk.

TMP_RUBY_PREFIX would be needed to fix it.
#5 - 02/19/2013 09:29 PM - mame (Yusuke Endoh)

- Assignee changed from mame (Yusuke Endoh) to nobu (Nobuyoshi Nakada)

Too many!  Are they all essential?

Could you please show me one minimum and clean patch?

--

Yusuke Endoh mame@tsg.ne.jp

#6 - 02/19/2013 10:17 PM - nobu (Nobuyoshi Nakada)

The former 4 commits are needed, and the last is fix of commit miss in Changelog.

And, I've backported them for [Bug #7871].

Please revert it if wrong.

#7 - 02/20/2013 03:15 PM - mame (Yusuke Endoh)

Please revert it if wrong.

 Please don't try to get retrospective approval ;-(

r39320 seems very subtle (actually it caused cascading fixes on trunk).

I'm afraid if it affects other platforms.

Eric Hodel,

Do you understand the fix?  It is related to rubygems (according to this ticket).

Chris White, Jon Forums,

Can you check the current ruby_2_0_0 branch and make sure that your issue(s) is really fixed?

--

Yusuke Endoh mame@tsg.ne.jp

#8 - 02/21/2013 05:24 AM - drbrain (Eric Hodel)

I don't know enough about autoconf to understand the fix.

I don't believe it will cause any problems with RubyGems though.

#9 - 02/21/2013 09:19 AM - jonforums (Jon Forums)

Chris White, Jon Forums,

Can you check the current ruby_2_0_0 branch and make sure that your issue(s) is really fixed?

 mame-san...ruby_2_0_0@39344 solves these recent issues on my x86_64-linux (ubuntu server 12.10) machine. I will build i686-linux later tonight

and report back if any errors.

exec_prefix regression

gem {install,update} --user-install errors

#10 - 02/23/2013 03:37 PM - mame (Yusuke Endoh)

Oops, this caused #7915...

I'm now keen to revert the bunch of patches.  What do you think?

--

Yusuke Endoh mame@tsg.ne.jp

#11 - 02/24/2013 02:06 PM - mame (Yusuke Endoh)

- Status changed from Assigned to Closed

I talked with nobu, and he said he could not reproduce #7915.

I decided to leave the backport as is.  Sorry if my decision is wrong...

I'm closing this ticket.
--

Yusuke Endoh mame@tsg.ne.jp

#12 - 12/21/2021 07:26 AM - nobu (Nobuyoshi Nakada)

- Description updated

#13 - 12/21/2021 07:30 AM - nobu (Nobuyoshi Nakada)

- Related to Bug #18373: Bundled gem (RBS, debug) extensions are not properly built added
